#define M 10000
#define lM 4

#include <stdio.h>
#include <algorithm>
#include <queue>
#include <vector>

using namespace std;

queue<int> q;
int a[M], up[lM];

inline void bp(vector<int> d, int step, vector<int> & result)
{
    if (step == d.size())
    {
        int cur = 0;
        for (int i = 0; i < d.size(); i++)
            cur = cur * 10 + d[up[i]];
        result.push_back(cur);
    } else
        for (int i = 0; i < d.size(); i++)
            if (up[i] == -1 && ! (i == 0 && d[step] == 0))
            {
                up[i] = step;
                bp(d, step + 1, result);
                up[i] = -1;
            }
}

inline vector<int> permutations(int K)
{
    vector<int> result;
    vector<int> d;
    while (K > 0)
    {
        d.push_back(K % 10);
        K /= 10;
    }
    for (int i = 0; i < d.size(); i++)
        up[i] = -1;
    bp(d, 0, result);
    return result;
}

int answer(int N)
{
    a[1] = 0;
    q.push(1);
    while (true)
    {
        int K = q.front();
        q.pop();
        vector<int> p = permutations(K);
        for (int i = 0; i < p.size(); i++)
            if (a[p[i]] == -1)
            {
                a[p[i]] = a[K] + 1;
                if (p[i] == N)
                    return a[N];
                q.push(p[i]);
            }
        if (K + 1 < M && a[K + 1] == -1)
        {
            a[K + 1] = a[K] + 1;
            if (K + 1 == N)
                return a[N];
            q.push(K + 1);
        }
    }
}

int main()
{
    freopen("numbers.dat", "r", stdin);
    freopen("numbers.sol", "w", stdout);

    for (int i = 0; i < M; i++)
        a[i] = -1;
    answer(M - 1);

    int T;
    scanf("%d", &T);
    for (int i = 0; i < T; i++)
    {
        int N;
        scanf("%d", &N);
        printf("%d\n", a[N]);
    }

    return 0;
}
