#define _CRT_SECURE_NO_DEPRECATE
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <iostream>
#include <iterator>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <sstream>
#include <fstream>
#include <ctime>
#include <cstring>
#include <functional>
#include <bitset>
#pragma comment(linker, "/STACK:66777216")
using namespace std;
#define pb push_back
#define ppb pop_back
#define pi 3.1415926535897932384626433832795028841971
#define mp make_pair
#define x first
#define y second
#define pii pair<int,int>
#define pdd pair<double,double>
#define INF 1000000000
#define FOR(i,a,b) for (int _n(b), i(a); i <= _n; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;i--)
#define all(c) (c).begin(), (c).end()
#define SORT(c) sort(all(c))
#define rep(i,n) FOR(i,1,(n))
#define rept(i,n) FOR(i,0,(n)-1)
#define L(s) (int)((s).size())
#define C(a) memset((a),0,sizeof(a))
#define VI vector <int>
#define ll long long
#define T long double
#define pld pair<T, T>

inline pii operator -(const pii &a, const pii &b) {
	return mp(a.x - b.x, a.y - b.y);
}
inline pld operator -(const pld &a, const pld &b) {
	return mp(a.x - b.x, a.y - b.y);
}
int a, b, c, d, n, m, k;
pld mas[50002], hum[50002];
pii ed[100002];
vector<pii> lf[50002], rt[50002];
pair<long double, pii> ev[200002];

int pr[300002], cnt[300002];
int p(int a) {
	if (pr[a] == -1) return a; else
	return pr[a] = p(pr[a]);
}
inline void un(int a, int b) {
	a = p(a); b = p(b);
	if (a == b) return; 
	pr[b] = a;
	cnt[a] += cnt[b];
}

T X;
struct seg {
	pld p1, p2;
	int com_up, num;
	T slope;
	seg(const pld &_p1, const pld &_p2, const int &_num = -1, const int &_com_up = -1) : p1(_p1), p2(_p2), num(_num), com_up(_com_up) {
		slope = (p2.y - p1.y) / (p2.x - p1.x);
	}
	inline T eval(const T &X) const {
		return p1.y + slope * (X - p1.x);
	}
};
struct Comp {
	inline bool operator ()(const seg &a, const seg &b) {
		return a.eval(X) < b.eval(X);
	}
};
pld base;
inline bool cmp(const pii &a, const pii &b) {
	pld v1 = mas[a.x] - base;
	pld v2 = mas[b.x] - base;
	return v1.x * v2.y - v2.x * v1.y > 0;
}

inline set<seg, Comp>::iterator fnd(set<seg, Comp> &q, int e) {
	pld p1 = mas[ed[e].x];
	pld p2 = mas[ed[e].y];
	if (p1 > p2) swap(p1, p2);
	set<seg, Comp>::iterator it = q.lower_bound(seg(p1, p2)), it2;
	if (it->num == e) return it;
	it2 = it;
	while (it != q.begin() || it2 != q.end()) {
		if (it != q.begin()) {
			--it;
			if (it->num == e) return it;
		}
		if (it2 != q.end()) {
			if (it2->num == e) return it2;
			++it2;
		}
	}
	return q.end();
}
int main() {
	freopen("archeology.dat", "r", stdin);
	freopen("archeology.sol", "w", stdout);
	
	scanf("%d%d%d", &n, &m, &k);
	rept(i, n) {
		scanf("%d%d", &a, &b);
		mas[i].x = a; mas[i].y = b;
	}

	rept(i, m) {
		scanf("%d%d", &a, &b); --a; --b;
		ed[i] = mp(a, b);
	}
	
	rept(i, k) {
		scanf("%d%d", &a, &b);
		hum[i].x = a; hum[i].y = b;
	}

	const long double alpha = 42;
	const long double ca = cos(alpha), sa = sin(alpha);
	c = 0;
	rept(i, n) {
		long double x = mas[i].x * ca + mas[i].y * sa;
		long double y = -mas[i].x * sa + mas[i].y * ca;
		mas[i] = mp(x, y);
		ev[c++] = mp(mas[i].x, mp(0, i));
	}
	rept(i, k) {
		long double x = hum[i].x * ca + hum[i].y * sa;
		long double y = -hum[i].x * sa + hum[i].y * ca;
		hum[i] = mp(x, y);
		ev[c++] = mp(hum[i].x, mp(1, i));
	}

	rept(i, m) {
		a = ed[i].x;
		b = ed[i].y;
		if (mas[a].x > mas[b].x) swap(a, b);
		rt[a].pb(mp(b, i));
		lf[b].pb(mp(a, i));
	}

	rept(i, n) {
		base = mas[i];
		sort(all(lf[i]), cmp);
		reverse(all(lf[i]));
		sort(all(rt[i]), cmp);
	}

	sort(ev, ev + c);
	set<seg, Comp> q;
	q.insert(seg(mp(-1000001, -1e20), mp(1000001, -1e20), -1, 0));
	q.insert(seg(mp(-1000001, 1e20), mp(1000001, 1e20), -2, -1));
	int nc = 1;
	memset(pr, -1, sizeof(pr));
	rept(i, c) {
		if (ev[i].y.x == 0) {
			int v = ev[i].y.y;
			int c_down = -1, c_up = -1;
			if (L(lf[v])) {
				X = (ev[i - 1].x + ev[i].x) / 2;
				set<seg, Comp>::iterator it = fnd(q, lf[v][0].y);
				set<seg, Comp>::iterator it2 = fnd(q, lf[v].back().y);
				--it;
				c_down = it->com_up;
				c_up = it2->com_up;
				rept(j, L(lf[v])) {
					q.erase(fnd(q, lf[v][j].y));
				}
				if (!L(rt[v])) {
					un(c_down, c_up);
				}
			}
			if (L(rt[v])) {
				if (!L(lf[v])) {
					X = ev[i].x;
					set<seg, Comp>::iterator it = q.upper_bound(seg(mp(X - 10, mas[v].y), mp(X + 10, mas[v].y)));
					--it;
					c_up = it->com_up;
				}
				X = (ev[i].x + ev[i + 1].x) / 2;
				rept(j, L(rt[v])) {
					int w = rt[v][j].x;
					int cur = -1;
					if (j < L(rt[v]) - 1) {
						cur = nc++;
					} else {
						if (c_up != -1) cur = c_up; else
						cur = nc++;
					}
					q.insert(seg(mas[v], mas[w], rt[v][j].y, cur));
				}
			}
		}
		else {
			int v = ev[i].y.y;
			X = ev[i].x;
			set<seg, Comp>::iterator it = q.upper_bound(seg(mp(X - 10, hum[v].y), mp(X + 10, hum[v].y)));
			--it;
			++cnt[p(it->com_up)];
		}
	}

	ll ans = 0;
	rept(i, nc) {
		if (pr[i] != -1) continue;
		ans += (ll)cnt[i] * (cnt[i] - 1) / 2;
	}
	cout << ans << endl;
}
